Bug 890839 - Review Request: slic3r - G-code generator for 3D printers (RepRap, Makerbot, Ultimaker etc.)
Review Request: slic3r - G-code generator for 3D printers (RepRap, Makerbot, ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: T.C. Hollingsworth
Fedora Extras Quality Assurance
:
Depends On: 876408 876409 876928 878680 887846 887913 890799 890803 890806 907036
Blocks:
  Show dependency treegraph
 
Reported: 2012-12-30 10:09 EST by Miro Hrončok
Modified: 2013-08-07 16:19 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-07 16:19:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tchollingsworth: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Miro Hrončok 2012-12-30 10:09:57 EST
Spec URL: https://raw.github.com/hroncok/SPECS/master/slic3r.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/slic3r-0.9.7-1.fc17.src.rpm

Description:

Slic3r is a G-code generator for 3D printers. It's compatible with RepRaps,
Makerbots, Ultimakers and many more machines.
See the project homepage at slic3r.org and the documentation on the Slic3r wiki
for more information.

Fedora Account System Username: churchyard
Comment 1 Miro Hrončok 2013-01-16 23:20:19 EST
Spec URL: https://raw.github.com/hroncok/SPECS/master/slic3r.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/slic3r-0.9.7-3.fc18.src.rpm

- Updated source to respect GitHub rule
- Dropped mkdir, ln -s, cp, mv, perl macros
- Reorganised %%install section a bit
- Added Require perl(Math::Clipper)
- Added version to Require perl(Math::Clipper)
Comment 3 Miro Hrončok 2013-01-21 15:19:19 EST
I'm having serious issues with 0.9.8, so for now, please use:

https://github.com/downloads/hroncok/SPECS/slic3r-0.9.7-3.fc18.src.rpm

Also, there are warnings (both in 0.9.7 and 0.9.8):

Running Slic3r under Perl >= 5.16 is not supported nor recommended

I'm going to investigate.
Comment 4 Miro Hrončok 2013-01-21 18:59:56 EST
Perl changed it's locales behavior in 5.16 and upstream has registered several serious issues (as well as me), therefor they refused to support Perl >=5.16. Setting LC_NUMERIC to English enforces decimal separator to be a point and fixes all issues found. Contacted upstream with this solution and patched it here.

Spec URL: https://raw.github.com/hroncok/SPECS/master/slic3r.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/slic3r-0.9.8-2.fc18.src.rpm

- Added patch to grab icons from %%{datadir}/%%{name}
- Added patch to avoid bad locales behavior
- Removed no longer needed filtering perl(Wx::Dialog) from Requires
- Filter perl(XML::SAX::PurePerl) only in F17
- Removed Perl default filter
- Removed Bash launcher
- Renamed slic3r.pl to slic3r
Comment 5 T.C. Hollingsworth 2013-01-24 15:32:00 EST
Might as well go ahead and review this while you're waiting on the last dep.
Comment 6 T.C. Hollingsworth 2013-01-24 16:40:33 EST
Ugh, it won't build without the missing dep, even if I drop %check.  If you can produce an SRPM that builds I can review it, otherwise it'll have to wait for the dep. 

+ perl Build.PL installdirs=vendor 'optimize=-O2 -g -pipe -Wall -Wp,-D_FORTIFY_S
OURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4  -m64 -mtune=ge
neric'
Checking prerequisites...
  requires:
    !  Math::PlanePath is not installed
ERRORS/WARNINGS FOUND IN PREREQUISITES.  You may wish to install the versions
of the modules indicated above before proceeding with this installation
Run 'Build installdeps' to install missing prerequisites.
cpan_client 'cpan' is not executable
error: Bad exit status from /var/tmp/rpm-tmp.w8KMGl (%build)
RPM build errors:
    Bad exit status from /var/tmp/rpm-tmp.w8KMGl (%build)
Child return code was: 1
EXCEPTION: Command failed. See logs for output.
Comment 7 Miro Hrončok 2013-01-25 11:36:35 EST
We'll wait.
Comment 8 T.C. Hollingsworth 2013-03-08 17:17:27 EST
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed

Status: NEEDS WORK

==== Issues ====

[!]: No justification provided for patches.

     Please add a comment with an upstream bug/patch link or justify any
     Fedora-specfic patches.  For more information, see:
     https://fedoraproject.org/wiki/Packaging:Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install if there is
     such a file.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 1 files have unknown license. Detailed output of
     licensecheck in
     /home/fedora/patches/FedoraReview/890839-slic3r/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[-]: Large documentation must go in a -doc subpackage.
[x]: Packages must not store files under /srv, /opt or /usr/local
  
Perl:
[x]: Package contains the mandatory BuildRequires and Requires:.
[x]: CPAN urls should be non-versioned.
     Note: Test run failed

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: slic3r-0.9.8-2.fc19.src.rpm
          slic3r-0.9.8-2.fc19.noarch.rpm
slic3r.noarch: W: no-manual-page-for-binary slic3r
2 packages and 0 specfiles checked; 0 errors, 1 warnings.

OK GUI


Rpmlint (installed packages)
----------------------------
# rpmlint slic3r
slic3r.noarch: W: no-manual-page-for-binary slic3r
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'

Ditto

Requires
--------
slic3r-0.9.8-2.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/perl
    perl >= 1:5.10
    perl(:MODULE_COMPAT_5.16.2)
    perl(Boost::Geometry::Utils)
    perl(Config)
    perl(Encode)
    perl(Encode::Locale)
    perl(Exporter)
    perl(File::Basename)
    perl(File::Spec)
    perl(FindBin)
    perl(Getopt::Long)
    perl(Growl::GNTP)
    perl(IO::Scalar)
    perl(List::Util)
    perl(Math::Clipper) >= 1.17
    perl(Math::ConvexHull::MonotoneChain)
    perl(Math::Geometry::Voronoi)
    perl(Math::PlanePath::ArchimedeanChords)
    perl(Math::PlanePath::Flowsnake)
    perl(Math::PlanePath::HilbertCurve)
    perl(Math::PlanePath::OctagramSpiral)
    perl(Moo)
    perl(Moo) >= 0.091009
    perl(Net::DBus)
    perl(SVG)
    perl(Scalar::Util)
    perl(Slic3r)
    perl(Slic3r::Config)
    perl(Slic3r::ExPolygon)
    perl(Slic3r::Extruder)
    perl(Slic3r::ExtrusionLoop)
    perl(Slic3r::ExtrusionPath)
    perl(Slic3r::ExtrusionPath::Arc)
    perl(Slic3r::ExtrusionPath::Collection)
    perl(Slic3r::Fill)
    perl(Slic3r::Fill::ArchimedeanChords)
    perl(Slic3r::Fill::Base)
    perl(Slic3r::Fill::Concentric)
    perl(Slic3r::Fill::Flowsnake)
    perl(Slic3r::Fill::HilbertCurve)
    perl(Slic3r::Fill::Honeycomb)
    perl(Slic3r::Fill::Line)
    perl(Slic3r::Fill::OctagramSpiral)
    perl(Slic3r::Fill::PlanePath)
    perl(Slic3r::Fill::Rectilinear)
    perl(Slic3r::Flow)
    perl(Slic3r::Format::AMF)
    perl(Slic3r::Format::OBJ)
    perl(Slic3r::Format::STL)
    perl(Slic3r::GCode)
    perl(Slic3r::GUI::AboutDialog)
    perl(Slic3r::GUI::ConfigWizard)
    perl(Slic3r::GUI::ConfigWizard::Page)
    perl(Slic3r::GUI::OptionsGroup)
    perl(Slic3r::GUI::Plater)
    perl(Slic3r::GUI::SkeinPanel)
    perl(Slic3r::GUI::Tab)
    perl(Slic3r::Geometry)
    perl(Slic3r::Geometry::Clipper)
    perl(Slic3r::Layer)
    perl(Slic3r::Layer::Region)
    perl(Slic3r::Line)
    perl(Slic3r::Model)
    perl(Slic3r::Point)
    perl(Slic3r::Polygon)
    perl(Slic3r::Polyline)
    perl(Slic3r::Print)
    perl(Slic3r::Print::Object)
    perl(Slic3r::Print::Region)
    perl(Slic3r::Surface)
    perl(Slic3r::TriangleMesh)
    perl(Time::HiRes)
    perl(Wx)
    perl(Wx) >= 0.9901
    perl(Wx::App)
    perl(Wx::DND)
    perl(Wx::Dialog)
    perl(Wx::Event)
    perl(Wx::FileDropTarget)
    perl(Wx::Html)
    perl(Wx::Panel)
    perl(Wx::Print)
    perl(Wx::ScrolledWindow)
    perl(Wx::StatusBar)
    perl(Wx::Wizard)
    perl(Wx::WizardPage)
    perl(XML::SAX)
    perl(XML::SAX::Base)
    perl(base)
    perl(constant)
    perl(lib)
    perl(parent)
    perl(strict)
    perl(threads::shared)
    perl(utf8)
    perl(warnings)

OK

Provides
--------
slic3r-0.9.8-2.fc19.noarch.rpm:
    
    perl(Slic3r) = 0.9.8
    perl(Slic3r::Config)
    perl(Slic3r::ExPolygon)
    perl(Slic3r::ExPolygon::Collection)
    perl(Slic3r::Extruder)
    perl(Slic3r::ExtrusionLoop)
    perl(Slic3r::ExtrusionLoop::Packed)
    perl(Slic3r::ExtrusionPath)
    perl(Slic3r::ExtrusionPath::Arc)
    perl(Slic3r::ExtrusionPath::Collection)
    perl(Slic3r::ExtrusionPath::Packed)
    perl(Slic3r::Fill)
    perl(Slic3r::Fill::ArchimedeanChords)
    perl(Slic3r::Fill::Base)
    perl(Slic3r::Fill::Concentric)
    perl(Slic3r::Fill::Flowsnake)
    perl(Slic3r::Fill::HilbertCurve)
    perl(Slic3r::Fill::Honeycomb)
    perl(Slic3r::Fill::Line)
    perl(Slic3r::Fill::OctagramSpiral)
    perl(Slic3r::Fill::PlanePath)
    perl(Slic3r::Fill::Rectilinear)
    perl(Slic3r::Flow)
    perl(Slic3r::Format::AMF)
    perl(Slic3r::Format::AMF::Parser)
    perl(Slic3r::Format::OBJ)
    perl(Slic3r::Format::STL)
    perl(Slic3r::GCode)
    perl(Slic3r::GUI)
    perl(Slic3r::GUI::AboutDialog)
    perl(Slic3r::GUI::AboutDialog::Logo)
    perl(Slic3r::GUI::ConfigOptionsGroup)
    perl(Slic3r::GUI::ConfigWizard)
    perl(Slic3r::GUI::ConfigWizard::Index)
    perl(Slic3r::GUI::ConfigWizard::Page)
    perl(Slic3r::GUI::ConfigWizard::Page::Bed)
    perl(Slic3r::GUI::ConfigWizard::Page::BedTemperature)
    perl(Slic3r::GUI::ConfigWizard::Page::Filament)
    perl(Slic3r::GUI::ConfigWizard::Page::Finished)
    perl(Slic3r::GUI::ConfigWizard::Page::Firmware)
    perl(Slic3r::GUI::ConfigWizard::Page::Nozzle)
    perl(Slic3r::GUI::ConfigWizard::Page::Temperature)
    perl(Slic3r::GUI::ConfigWizard::Page::Welcome)
    perl(Slic3r::GUI::Notifier)
    perl(Slic3r::GUI::OptionsGroup)
    perl(Slic3r::GUI::OptionsGroup::StaticTextLine)
    perl(Slic3r::GUI::Plater)
    perl(Slic3r::GUI::Plater::DropTarget)
    perl(Slic3r::GUI::Plater::Object)
    perl(Slic3r::GUI::Plater::ObjectInfoDialog)
    perl(Slic3r::GUI::ProgressStatusBar)
    perl(Slic3r::GUI::SavePresetWindow)
    perl(Slic3r::GUI::SkeinPanel)
    perl(Slic3r::GUI::Tab)
    perl(Slic3r::GUI::Tab::Filament)
    perl(Slic3r::GUI::Tab::Page)
    perl(Slic3r::GUI::Tab::Print)
    perl(Slic3r::GUI::Tab::Printer)
    perl(Slic3r::Geometry)
    perl(Slic3r::Geometry::Clipper)
    perl(Slic3r::Layer)
    perl(Slic3r::Layer::Region)
    perl(Slic3r::Line)
    perl(Slic3r::Model)
    perl(Slic3r::Model::Instance)
    perl(Slic3r::Model::Object)
    perl(Slic3r::Model::Region)
    perl(Slic3r::Model::Volume)
    perl(Slic3r::Point)
    perl(Slic3r::Polygon)
    perl(Slic3r::Polyline)
    perl(Slic3r::Polyline::Collection)
    perl(Slic3r::Print)
    perl(Slic3r::Print::Object)
    perl(Slic3r::Print::Region)
    perl(Slic3r::SVG)
    perl(Slic3r::Surface)
    perl(Slic3r::Test)
    perl(Slic3r::Test::GCodeReader)
    perl(Slic3r::TriangleMesh)
    slic3r = 0.9.8-2.fc19

OK

MD5-sum check
-------------
https://github.com/alexrj/Slic3r/archive/71052433de0ff1f3da04471ccbb572babafc3cae/slic3r-0.9.8-7105243.tar.gz :
  CHECKSUM(SHA256) this package     : fbaa458716cb47c7167da78ad84207f59385eb6aece9b44833fa5fb3e8f74721
  CHECKSUM(SHA256) upstream package : fbaa458716cb47c7167da78ad84207f59385eb6aece9b44833fa5fb3e8f74721

OK

Generated by fedora-review 0.3.1 (f4bc12d) last change: 2012-10-16
Buildroot used: fedora-rawhide-vanilla-x86_64
Command line :./try-fedora-review -b890839
Comment 9 Miro Hrončok 2013-03-11 09:59:44 EDT
Thanks.

Spec URL: https://raw.github.com/hroncok/SPECS/master/slic3r.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/slic3r-0.9.8-3.fc18.src.rpm

In-file justification provided for patches.
Comment 10 T.C. Hollingsworth 2013-03-15 20:39:18 EDT
Did you forget to upload a new spec?  I don't see any comments added to the patches.
Comment 11 Miro Hrončok 2013-03-17 04:28:49 EDT
No. Only change in spec is in chnagelog. I'll explained the patches in the patches.
Comment 12 Miro Hrončok 2013-03-17 04:38:43 EDT
Sorry. I've explained the patches in the patches.
Comment 13 T.C. Hollingsworth 2013-03-19 06:02:05 EDT
Please add comments to the spec file as well, as described at:
https://fedoraproject.org/wiki/Packaging:Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

`git format-patch` is awesome and all, but it's really useful to be able to figure out what's going on solely from the spec file.
Comment 14 Miro Hrončok 2013-03-20 10:15:31 EDT
Oh, OK.

Spec URL: https://raw.github.com/hroncok/SPECS/master/slic3r.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/slic3r-0.9.8-4.fc18.src.rpm

As the reasons for slic3r-english-locale.patch are complicated, I wrote:

# Use English decimal separator for numbers
# Reasons are a bit complicated and are described in the patch
Patch1:         %{name}-english-locale.patch

Hope, that's enough (I don't want the long justification in spec as a comment).
Comment 15 T.C. Hollingsworth 2013-03-20 16:53:42 EDT
Fine by me.  LC_NUMERIC issues with the decimal seperator have been popping up in other packages lately anyway, so that would be sufficient for those in the know anyway.  ;-)

This package is APPROVED.
Comment 16 Miro Hrončok 2013-03-21 10:11:49 EDT
Thanks.
Comment 17 Miro Hrončok 2013-03-21 10:13:22 EDT
New Package SCM Request
=======================
Package Name: slic3r
Short Description: G-code generator for 3D printers (RepRap, Makerbot, Ultimaker etc.)
Owners: churchyard
Branches: f17 f18 f19
InitialCC: perl-sig
Comment 18 Jon Ciesla 2013-03-21 10:24:26 EDT
Git done (by process-git-requests).
Comment 19 Fedora Update System 2013-04-22 14:20:32 EDT
slic3r-0.9.9-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/slic3r-0.9.9-1.fc19
Comment 20 Fedora Update System 2013-04-22 14:21:35 EDT
slic3r-0.9.9-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/slic3r-0.9.9-1.fc18
Comment 21 Fedora Update System 2013-04-22 14:22:28 EDT
slic3r-0.9.7-4.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/slic3r-0.9.7-4.fc17
Comment 22 Fedora Update System 2013-04-22 22:58:37 EDT
slic3r-0.9.9-1.fc19 has been pushed to the Fedora 19 testing repository.
Comment 23 Fedora Update System 2013-04-23 09:00:41 EDT
slic3r-0.9.9-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/slic3r-0.9.9-2.fc19
Comment 24 Fedora Update System 2013-04-23 09:35:05 EDT
slic3r-0.9.9-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/slic3r-0.9.9-3.fc18

Note You need to log in before you can comment on or make changes to this bug.